org.codehaus.groovy.control.io

## Class InputStreamReaderSource

- java.lang.Object
- - org.codehaus.groovy.control.io.AbstractReaderSource
  - - org.codehaus.groovy.control.io.InputStreamReaderSource

- All Implemented Interfaces:
    HasCleanup, ReaderSource

      public class InputStreamReaderSource
      extends AbstractReaderSource

  A ReaderSource for source strings.
  Author:
    Chris Poirier

- - ### Field Summary

    - ### Fields inherited from class org.codehaus.groovy.control.io.AbstractReaderSource

      `configuration`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InputStreamReaderSource(java.io.InputStream stream, CompilerConfiguration configuration)` Creates the ReaderSource from a File descriptor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canReopenSource()` Returns true if the source can be restarted (ie.
    `java.io.Reader` | `getReader()` Returns a new Reader on the underlying source object.
    `java.net.URI` | `getURI()` TODO: Should return the URI for this source, but we can't know what it is here.

    - ### Methods inherited from class org.codehaus.groovy.control.io.AbstractReaderSource

      `cleanup, getLine`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### InputStreamReaderSource

          public InputStreamReaderSource(java.io.InputStream stream,
                                         CompilerConfiguration configuration)

      Creates the ReaderSource from a File descriptor.
      Parameters:
        `stream` - stream containing source
        `configuration` - configuration for compiling source

  - ### Method Detail

    - #### getReader

          public java.io.Reader getReader()
                                   throws java.io.IOException

      Returns a new Reader on the underlying source object.
      Returns:
        the reader to the resource
      Throws:
        `java.io.IOException` - if there was an error opening for stream

    - #### canReopenSource

          public boolean canReopenSource()

      Returns true if the source can be restarted (ie. if getReader() will return non-null on subsequent calls.
      Specified by:
        `canReopenSource` in interface `ReaderSource`
      Overrides:
        `canReopenSource` in class `AbstractReaderSource`
      Returns:
        true if the resource can be reopened for reading

    - #### getURI

          public java.net.URI getURI()

      TODO: Should return the URI for this source, but we can't know what it is here.
      Returns:
        null